int dec,uni,decimal,dato,aux;
int const disp[10]  = {0x3F, 0x06, 0x5B, 0x4F,                 //Se declaran como constantes
                       0x66, 0x6D, 0x7D, 0x07, 0x7F, 0x6F};   //Codigo Hexa para cada nuemro 
int const id[27] = {0X77,0X7C,0X39,0X5E,0x79,0x71,0x3d,0x76,0x06,0x1e,0x76,0x38,0x4F,0x54,0x55,0x5c,0x73,0x67,0x50,0x6d,0x70,0x1c,0x3e,0x4f,0x76,0x6e,0x5b};
                  // A  , B  , C  , D  , E  , F  , G  , H  , I  , J  , K  , L  , M  , N  ,   , O  , P  , Q  , R  , S  , T  , U  , V  , W  , X  , Y  , Z
                  // 0  , 1  , 2  , 3  , 4  , 5  , 6  , 7  , 8  , 9  , 10 , 11 ,12  ,13  ,14  ,15  ,16  ,17  ,18  ,19  ,20  ,21  ,22  ,23  ,24  ,25  ,26
int const cam[9] = {0,1,2,4,8,16,32,64,128};

int espejo(int temp1)		//Funcion Para invertir Bits de una variable
{ int temp2=0;
if ((temp1&0x01)==0x01)
temp2=temp2+128;
if ((temp1&0x02)==0x02)
temp2=temp2+64;
if ((temp1&0x04)==0x04)
temp2=temp2+32;
if ((temp1&0x08)==0x08)
temp2=temp2+16;
if ((temp1&0x10)==0x10)
temp2=temp2+8;
if ((temp1&0x20)==0x20)
temp2=temp2+4;
if ((temp1&0x40)==0x40)
temp2=temp2+2;
if ((temp1&0x80)==0x80)
temp2=temp2+1;
return temp2;
}

int j1(int cont, int temp) // funcion que me permite simular el juego de cada jugfador
{ int alea,gana=0;
 if (cont==1)
 {
  while(!PORTA.F2)
  {
  
   if (alea==4)
   alea=0;
   alea++;         // se genera un num aleatorio entre 1 y 4 para avanzar cada jugador
  }

  temp=temp+alea;       
  if(temp>8)
  PORTB=0;
  else
  PORTB=cam[temp]; // se muestra el camino de leds en el PORTB

  Delay_ms(100);
 
 
 
 
  return temp;
 }
 
 while(!PORTA.F3)
  {
  
   if (alea==4)
   alea=0;
   alea++;
  }

  temp=temp+alea;
  if(temp>8)
  PORTB=0;
  else
  PORTB=cam[temp];

  Delay_ms(100);
  
 
  return temp;
}

void p1()
{ 

ADC_Init();				//inicializo el ADC
while(1)
{

dato=ADC_Read(0);       //entrada analogica 0

aux=(dato/10.23);  		//division perfecta para marcar rango 
if(aux<=99)
{
dec=aux/10;       		//division para extraer decimal del dato anterior
uni=aux%10;      		//modulo (residuo de la division) para extraer unidades
}
if(aux==100)
{
dec=0;
uni=0;
}
PORTB=espejo(aux);		// muestro el valor binario en el PORTB
PORTC=disp[uni];		// muestro valor unidaades en el PORTC.
PORTD=disp[dec];		// muestro valor decenas en el PORTD



}
}

void p2()
{
int alea=0, temp=0, cont=0, gana=0, juga=0;        //declaracion de variables

do{                                                                //se enceran displays
PORTC=disp[0];
PORTD=disp[0];

}while(PORTA.F2);                                // se valida que suelte la Botonera


while(1)
{

 while(!PORTA.F1) // lazo infinito
 {                // genera un valor aleatorio entre 1 y 4 y lo slamcena en la variable alea                       
                   // se genera el numero cuando se presiona la BOTONERA1
  if (alea==4)
  alea=0;
  alea++;
  PORTD=disp[alea];
  Delay_ms(100);
 }
 
 temp=alea;
 PORTB=cam[temp]; //se muestra el numero generado en el PORTB
 
 Delay_ms(100);
 
 if(alea%2==0)  // aprovechamos el numero aleatorio anterior para elejiir que jugador empieza
 juga=2;         //diviendo el numero para 2: si es par comienza el jugador 2 caso contrario comienzxa el jugador 1
 else
 juga=1;
 
 
 
 while(1)
 {
 if(juga==1)   // si empezo el jugador 1
 {
  PORTD=disp[0];        
  PORTC=disp[juga];  
  temp=j1(juga,temp); //se mjuestrta la jugada en el camino de LEDs
  if((temp>=8)&&juga==1) //alcanza o supera el tope del camino gana
  { 
   gana=1;
   break;
   }
  juga=2;
  }
 if(juga==2)
 {
   PORTd=disp[0];     // sino sigue jugando el jugador adversario
   PORTC=disp[juga];
  temp=j1(juga,temp);
  if((temp>=8)&&juga==2) //si alcanza o supera el valor de 8 gana el otro jugador
  {
   gana=2;
   break;
   }
  juga=1;
 }
 
 }
 
 if(gana==1) // se muestra si gano el jugfador 1
 {
  PORTD=id[6];
  PORTC=disp[1];
  Delay_ms(1000);
  break;
 }
 
 if(gana==2) // se muestra si gano el jugador 2
 {
  PORTD=id[6];
  PORTC=disp[2];
  Delay_ms(1000);
  break;
 }
 return;
 }
 
 
 }

 

void main()
{
ANSEL=0x01;
ANSELH = 0;                 // Configure other AN pins as digital I/O
C1ON_bit = 0;               // Disable comparators
C2ON_bit = 0;
TRISA  = 0xFF;              // PORTA como entrada
TRISC  = 0;                 // PORTC como salida
TRISB  = 0;                 // PORTB como salida
TRISD  = 0;					// PORTD como salida

PORTB=0;					// inicializado en 0 el PORTB

while(1)
{
PORTC=id[3];				// iniciales
PORTD=id[2];				// iniciales
PORTB=0;
if(RA1_bit=1)				//prueba el bit 1 del PORTA
p1();
if(PORTA.F2=1)				//prueba el bit 2 del PORTA
p2();
}

}